// **************************************************************************************
// * Indicateur de rapport engagé pour moto 6 vitesses Version 1.00 du 22-04-2020		*
// * Copyright PRIN Jean-Luc															*
// **************************************************************************************


// Constantes des capteurs
const int plusPin = 6;         	// Broche reliée au capteur de rapport plus
const int neutrePin = 5;      	// Broche réliée au capteur du neutre
const int moinsPin = 4;       	// Broche reliée au capteur de rapport moins

// Constantes des broches de l'afficheur 7 segments
const int digitPin_0 = 7;
const int digitPin_1 = 8;
const int digitPin_2 = 3;
const int digitPin_3 = 1;
const int digitPin_4 = 2;
const int digitPin_5 = 10;
const int digitPin_6 = 9;

// Contante Attente entre chaque signal
const int attente = 800;

// Constante Nbre de rapports maxi
const int NbreMax = 6;

// Constantes de niveau du signal pour l'afficheur
// mettez en commentaire selon l'afficheur utilisé
// pour Anode commune, allumage des segments par mise au niveau Bas (+5V commun)
//const boolean CD_SEG = LOW;
//const boolean EX_SEG = HIGH;

// pour Cathode commune, allumage des segments par mise au niveau Haut (Masse commune)
const boolean CD_SEG = HIGH;
const boolean EX_SEG = LOW;

// Variables
int rapport = -1;     			// Rapport engagé
int moinsState = 0;             // Signal du capteur Moins
int neutreState = 0;          	// Signal du capteur Neutre
int plusState = 0;            	// Signal du capteur Plus
boolean action = false;   		// Action sur le sélecteur de rapport

void setup() {
  // Initialisation des broches reliées à l'afficheur 7 segments
  pinMode(digitPin_0, OUTPUT);
  pinMode(digitPin_1, OUTPUT);
  pinMode(digitPin_2, OUTPUT);
  pinMode(digitPin_3, OUTPUT);
  pinMode(digitPin_4, OUTPUT);
  pinMode(digitPin_5, OUTPUT);
  pinMode(digitPin_6, OUTPUT);
  // Initialialisation des broches reliées aux capteurs
  pinMode(moinsPin, INPUT_PULLUP);
  pinMode(neutrePin, INPUT_PULLUP);
  pinMode(plusPin, INPUT_PULLUP);
}

void loop() {
  // Lit l'état des capteurs
  moinsState = digitalRead(moinsPin);
  neutreState = digitalRead(neutrePin);
  plusState = digitalRead(plusPin);

  // Si le rapport engagé n'est pas connu (lors de la mise sous tension, si le sélecteur n'est pas au Neutre)
   if (rapport == -1) {
      affiche_trait();        // Affiche un trait
   }
   
  // Si le sélecteur de rapport est au neutre
  if (neutreState == LOW) {
    // Initialise le rapport et affiche 0
   rapport = 0;
   affiche(rapport);
    } else  if (moinsState == LOW and rapport != -1) {
   if (rapport == 0) {
      rapport = 1;
   }
   else  if (rapport  > 1) {
      rapport = rapport -1;
   }
   affiche(rapport);
   delay(attente);
    } else if (plusState == LOW and rapport != -1) {
      if (rapport < NbreMax) {
   if (rapport == 0) {
      rapport = 2;
   } else {
      rapport = rapport + 1;
   }
   affiche(rapport);
   delay(attente);
    }
    }
 }
 
 void affiche_trait() {
   digitalWrite(digitPin_0, EX_SEG);  
   digitalWrite(digitPin_1, EX_SEG);  
   digitalWrite(digitPin_2, EX_SEG);  
   digitalWrite(digitPin_3, EX_SEG);   
   digitalWrite(digitPin_4, EX_SEG);   
   digitalWrite(digitPin_5, EX_SEG);   
   digitalWrite(digitPin_6, CD_SEG);   
 }
 
 void affiche(int valeur) {
   switch(valeur) {
      case 0:
   digitalWrite(digitPin_0, CD_SEG);  
   digitalWrite(digitPin_1, CD_SEG);  
   digitalWrite(digitPin_2, CD_SEG);  
   digitalWrite(digitPin_3, CD_SEG);   
   digitalWrite(digitPin_4, CD_SEG);   
   digitalWrite(digitPin_5, CD_SEG);   
   digitalWrite(digitPin_6, EX_SEG); 
   break;
      case 1:
   digitalWrite(digitPin_0, EX_SEG);  
   digitalWrite(digitPin_1, CD_SEG);  
   digitalWrite(digitPin_2, CD_SEG);  
   digitalWrite(digitPin_3, EX_SEG);   
   digitalWrite(digitPin_4, EX_SEG);   
   digitalWrite(digitPin_5, EX_SEG);   
   digitalWrite(digitPin_6, EX_SEG);
   break;
      case 2:
   digitalWrite(digitPin_0, CD_SEG);  
   digitalWrite(digitPin_1, CD_SEG);  
   digitalWrite(digitPin_2, EX_SEG);  
   digitalWrite(digitPin_3, CD_SEG);   
   digitalWrite(digitPin_4, CD_SEG);   
   digitalWrite(digitPin_5, EX_SEG);   
   digitalWrite(digitPin_6, CD_SEG); 
   break;
      case 3:
   digitalWrite(digitPin_0, CD_SEG);  
   digitalWrite(digitPin_1, CD_SEG);  
   digitalWrite(digitPin_2, CD_SEG);  
   digitalWrite(digitPin_3, CD_SEG);   
   digitalWrite(digitPin_4, EX_SEG);   
   digitalWrite(digitPin_5, EX_SEG);   
   digitalWrite(digitPin_6, CD_SEG);
   break;
      case 4:
   digitalWrite(digitPin_0, EX_SEG);  
   digitalWrite(digitPin_1, CD_SEG);  
   digitalWrite(digitPin_2, CD_SEG);  
   digitalWrite(digitPin_3, EX_SEG);   
   digitalWrite(digitPin_4, EX_SEG);   
   digitalWrite(digitPin_5, CD_SEG);   
   digitalWrite(digitPin_6, CD_SEG); 
   break;
      case 5:
   digitalWrite(digitPin_0, CD_SEG);  
   digitalWrite(digitPin_1, EX_SEG);  
   digitalWrite(digitPin_2, CD_SEG);  
   digitalWrite(digitPin_3, CD_SEG);   
   digitalWrite(digitPin_4, EX_SEG);   
   digitalWrite(digitPin_5, CD_SEG);   
   digitalWrite(digitPin_6, CD_SEG); 
   break;
      case 6:
   digitalWrite(digitPin_0, CD_SEG);  
   digitalWrite(digitPin_1, EX_SEG);  
   digitalWrite(digitPin_2, CD_SEG);  
   digitalWrite(digitPin_3, CD_SEG);   
   digitalWrite(digitPin_4, CD_SEG);   
   digitalWrite(digitPin_5, CD_SEG);   
   digitalWrite(digitPin_6, CD_SEG); 
   break;
   }
}
